Index: /trunk/sources/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj
===================================================================
--- /trunk/sources/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj	(revision 6500)
+++ /trunk/sources/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj	(revision 6501)
@@ -140,16 +140,8 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\..\..\HeuristicLab.Algorithms.DataAnalysis.Views\3.3\HeuristicLab.Algorithms.DataAnalysis.Views-3.3.csproj">
-      <Project>{C3E69936-0DB5-42A4-B1B4-12E9700B080E}</Project>
-      <Name>HeuristicLab.Algorithms.DataAnalysis.Views-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.Algorithms.DataAnalysis.Views\3.4\HeuristicLab.Algorithms.DataAnalysis.Views-3.4.csproj">
       <Project>{A2330DB0-413D-4424-B4E6-591118E2B9F8}</Project>
       <Name>HeuristicLab.Algorithms.DataAnalysis.Views-3.4</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Algorithms.DataAnalysis\3.3\HeuristicLab.Algorithms.DataAnalysis-3.3.csproj">
-      <Project>{A8D5676D-9662-437A-B44D-ECB4046CDE12}</Project>
-      <Name>HeuristicLab.Algorithms.DataAnalysis-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.Algorithms.DataAnalysis\3.4\HeuristicLab.Algorithms.DataAnalysis-3.4.csproj">
       <Project>{2E782078-FA81-4B70-B56F-74CE38DAC6C8}</Project>
@@ -260,16 +252,8 @@
       <Name>HeuristicLab.Encodings.RealVectorEncoding-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views\3.3\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.3.csproj">
-      <Project>{6F42C5F8-16CD-43EE-8208-FD4573A69D85}</Project>
-      <Name>HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views\3.4\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4.csproj">
       <Project>{423BD94F-963A-438E-BA45-3BB3D61CD03B}</Project>
       <Name>HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding\3.3\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.csproj">
-      <Project>{125D3006-67F5-48CB-913E-73C0548F17FA}</Project>
-      <Name>HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding\3.4\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj">
       <Project>{06D4A186-9319-48A0-BADE-A2058D462EEA}</Project>
@@ -404,16 +388,4 @@
       <Name>HeuristicLab.Problems.ArtificialAnt-3.4</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Problems.DataAnalysis.Classification.Views\3.3\HeuristicLab.Problems.DataAnalysis.Classification.Views-3.3.csproj">
-      <Project>{7F038E9A-B91E-4F49-8C27-D47BC86F1220}</Project>
-      <Name>HeuristicLab.Problems.DataAnalysis.Classification.Views-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Problems.DataAnalysis.Classification\3.3\HeuristicLab.Problems.DataAnalysis.Classification-3.3.csproj">
-      <Project>{D35FD6DB-D704-4BEA-BDAE-C40ABFB5B13E}</Project>
-      <Name>HeuristicLab.Problems.DataAnalysis.Classification-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Problems.DataAnalysis.Regression\3.3\HeuristicLab.Problems.DataAnalysis.Regression-3.3.csproj">
-      <Project>{BDF86B1D-630E-4CE2-8A49-8C90B1BDE4C9}</Project>
-      <Name>HeuristicLab.Problems.DataAnalysis.Regression-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.Problems.DataAnalysis.Symbolic.Classification.Views\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic.Classification.Views-3.4.csproj">
       <Project>{BF1E4DF4-A4CC-451F-9D50-303F405E265E}</Project>
@@ -440,8 +412,4 @@
       <Name>HeuristicLab.Problems.DataAnalysis.Symbolic-3.4</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Problems.DataAnalysis.Views\3.3\HeuristicLab.Problems.DataAnalysis.Views-3.3.csproj">
-      <Project>{799B0B38-E384-4A17-A73C-F211EB854592}</Project>
-      <Name>HeuristicLab.Problems.DataAnalysis.Views-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.Problems.DataAnalysis.Views\3.4\HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj">
       <Project>{3E9E8944-44FF-40BB-A622-3A4A7DD0F198}</Project>
@@ -451,12 +419,4 @@
       <Project>{DF87C13E-A889-46FF-8153-66DCAA8C5674}</Project>
       <Name>HeuristicLab.Problems.DataAnalysis-3.4</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Problems.ExternalEvaluation.GP.Views\3.3\HeuristicLab.Problems.ExternalEvaluation.GP.Views-3.3.csproj">
-      <Project>{1778134B-866B-4CB3-BFC0-52B2FAAA5777}</Project>
-      <Name>HeuristicLab.Problems.ExternalEvaluation.GP.Views-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.Problems.ExternalEvaluation.GP\3.3\HeuristicLab.Problems.ExternalEvaluation.GP-3.3.csproj">
-      <Project>{E86E215D-E3CE-4244-978D-555D4E17AC09}</Project>
-      <Name>HeuristicLab.Problems.ExternalEvaluation.GP-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.Problems.ExternalEvaluation.GP\3.4\HeuristicLab.Problems.ExternalEvaluation.GP-3.4.csproj">