Index: /trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- /trunk/sources/HeuristicLab 3.3.sln	(revision 6501)
+++ /trunk/sources/HeuristicLab 3.3.sln	(revision 6502)
@@ -1447,6 +1447,6 @@
 		{66DABFD5-5BD2-4478-8DF9-C589F569F7A2}.Debug|x86.ActiveCfg = Debug|x86
 		{66DABFD5-5BD2-4478-8DF9-C589F569F7A2}.Debug|x86.Build.0 = Debug|x86
-		{66DABFD5-5BD2-4478-8DF9-C589F569F7A2}.Release|Any CPU.ActiveCfg = Release|x86
-		{66DABFD5-5BD2-4478-8DF9-C589F569F7A2}.Release|Any CPU.Build.0 = Release|x86
+		{66DABFD5-5BD2-4478-8DF9-C589F569F7A2}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{66DABFD5-5BD2-4478-8DF9-C589F569F7A2}.Release|Any CPU.Build.0 = Release|Any CPU
 		{66DABFD5-5BD2-4478-8DF9-C589F569F7A2}.Release|x64.ActiveCfg = Release|x64
 		{66DABFD5-5BD2-4478-8DF9-C589F569F7A2}.Release|x64.Build.0 = Release|x64
Index: /trunk/sources/HeuristicLab/3.3/Tests/SamplesTest.cs
===================================================================
--- /trunk/sources/HeuristicLab/3.3/Tests/SamplesTest.cs	(revision 6501)
+++ /trunk/sources/HeuristicLab/3.3/Tests/SamplesTest.cs	(revision 6502)
@@ -176,8 +176,15 @@
       ga.SetSeedRandomly.Value = false;
       RunAlgorithm(ga);
-      Assert.AreEqual(89, GetDoubleResult(ga, "BestQuality"));
-      Assert.AreEqual(68.635, GetDoubleResult(ga, "CurrentAverageQuality"));
-      Assert.AreEqual(0, GetDoubleResult(ga, "CurrentWorstQuality"));
-      Assert.AreEqual(50950, GetIntResult(ga, "EvaluatedSolutions"));
+      if (!Environment.Is64BitProcess) {
+        Assert.AreEqual(89, GetDoubleResult(ga, "BestQuality"));
+        Assert.AreEqual(68.635, GetDoubleResult(ga, "CurrentAverageQuality"));
+        Assert.AreEqual(0, GetDoubleResult(ga, "CurrentWorstQuality"));
+        Assert.AreEqual(50950, GetIntResult(ga, "EvaluatedSolutions"));
+      } else {
+        Assert.AreEqual(82, GetDoubleResult(ga, "BestQuality"));
+        Assert.AreEqual(65.594, GetDoubleResult(ga, "CurrentAverageQuality"));
+        Assert.AreEqual(0, GetDoubleResult(ga, "CurrentWorstQuality"));
+        Assert.AreEqual(50950, GetIntResult(ga, "EvaluatedSolutions"));
+      }
     }
 
@@ -228,8 +235,15 @@
       ga.SetSeedRandomly.Value = false;
       RunAlgorithm(ga);
-      Assert.AreEqual(0.82895806566669916, GetDoubleResult(ga, "BestQuality"));
-      Assert.AreEqual(0.50808259256341926, GetDoubleResult(ga, "CurrentAverageQuality"));
-      Assert.AreEqual(0, GetDoubleResult(ga, "CurrentWorstQuality"));
-      Assert.AreEqual(50950, GetIntResult(ga, "EvaluatedSolutions"));
+      if (!Environment.Is64BitProcess) {
+        Assert.AreEqual(0.82895806566669916, GetDoubleResult(ga, "BestQuality"));
+        Assert.AreEqual(0.50808259256341926, GetDoubleResult(ga, "CurrentAverageQuality"));
+        Assert.AreEqual(0, GetDoubleResult(ga, "CurrentWorstQuality"));
+        Assert.AreEqual(50950, GetIntResult(ga, "EvaluatedSolutions"));
+      } else {
+        Assert.AreEqual(0.80376816256837447, GetDoubleResult(ga, "BestQuality"));
+        Assert.AreEqual(0.56912229251001056, GetDoubleResult(ga, "CurrentAverageQuality"));
+        Assert.AreEqual(0, GetDoubleResult(ga, "CurrentWorstQuality"));
+        Assert.AreEqual(50950, GetIntResult(ga, "EvaluatedSolutions"));
+      }
     }
 
@@ -344,8 +358,15 @@
       ga.SetSeedRandomly.Value = false;
       RunAlgorithm(ga);
-      Assert.AreEqual(0.13607488888377872, GetDoubleResult(ga, "BestQuality"));
-      Assert.AreEqual(2.1634701155600293, GetDoubleResult(ga, "CurrentAverageQuality"));
-      Assert.AreEqual(100.62175156249987, GetDoubleResult(ga, "CurrentWorstQuality"));
-      Assert.AreEqual(100900, GetIntResult(ga, "EvaluatedSolutions"));
+      if (!Environment.Is64BitProcess) {
+        Assert.AreEqual(0.13607488888377872, GetDoubleResult(ga, "BestQuality"));
+        Assert.AreEqual(2.1634701155600293, GetDoubleResult(ga, "CurrentAverageQuality"));
+        Assert.AreEqual(100.62175156249987, GetDoubleResult(ga, "CurrentWorstQuality"));
+        Assert.AreEqual(100900, GetIntResult(ga, "EvaluatedSolutions"));
+      } else {
+        Assert.AreEqual(0.1343874434023121, GetDoubleResult(ga, "BestQuality"));
+        Assert.AreEqual(5.1125971846526053, GetDoubleResult(ga, "CurrentAverageQuality"));
+        Assert.AreEqual(100.62175156249987, GetDoubleResult(ga, "CurrentWorstQuality"));
+        Assert.AreEqual(100900, GetIntResult(ga, "EvaluatedSolutions"));
+      }
     }
 