Index: /trunk/sources/HeuristicLab/3.3/Tests/SamplesTest.cs
===================================================================
--- /trunk/sources/HeuristicLab/3.3/Tests/SamplesTest.cs	(revision 6543)
+++ /trunk/sources/HeuristicLab/3.3/Tests/SamplesTest.cs	(revision 6544)
@@ -1,38 +1,55 @@
-﻿using System;
-using System.Text;
-using System.Collections.Generic;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Linq;
-using Microsoft.VisualStudio.TestTools.UnitTesting;
+using System.Threading;
+using HeuristicLab.Algorithms.EvolutionStrategy;
 using HeuristicLab.Algorithms.GeneticAlgorithm;
-using HeuristicLab.Problems.ArtificialAnt;
-using HeuristicLab.Selection;
-using HeuristicLab.Data;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Persistence.Default.Xml;
-using HeuristicLab.Optimization;
-using System.Threading;
-using HeuristicLab.ParallelEngine;
-using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
-using HeuristicLab.Problems.DataAnalysis;
-using HeuristicLab.Problems.DataAnalysis.Symbolic;
-using System.IO;
-using HeuristicLab.Problems.DataAnalysis.Symbolic.Classification;
-using HeuristicLab.Problems.TravelingSalesman;
-using HeuristicLab.Encodings.PermutationEncoding;
-using HeuristicLab.Problems.VehicleRouting;
-using HeuristicLab.Problems.VehicleRouting.Encodings.Potvin;
-using HeuristicLab.Problems.VehicleRouting.Encodings;
-using HeuristicLab.Problems.VehicleRouting.Encodings.General;
-using HeuristicLab.Algorithms.EvolutionStrategy;
-using HeuristicLab.Encodings.RealVectorEncoding;
-using HeuristicLab.Problems.TestFunctions;
-using HeuristicLab.Optimization.Operators;
 using HeuristicLab.Algorithms.LocalSearch;
-using HeuristicLab.Problems.Knapsack;
-using HeuristicLab.Encodings.BinaryVectorEncoding;
 using HeuristicLab.Algorithms.ParticleSwarmOptimization;
 using HeuristicLab.Algorithms.SimulatedAnnealing;
 using HeuristicLab.Algorithms.TabuSearch;
 using HeuristicLab.Algorithms.VariableNeighborhoodSearch;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Operators;
+using HeuristicLab.ParallelEngine;
+using HeuristicLab.Persistence.Default.Xml;
+using HeuristicLab.Problems.ArtificialAnt;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Classification;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+using HeuristicLab.Problems.Knapsack;
+using HeuristicLab.Problems.TestFunctions;
+using HeuristicLab.Problems.TravelingSalesman;
+using HeuristicLab.Problems.VehicleRouting;
+using HeuristicLab.Problems.VehicleRouting.Encodings.General;
+using HeuristicLab.Problems.VehicleRouting.Encodings.Potvin;
+using HeuristicLab.Selection;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
 
 namespace HeuristicLab_33.Tests {
@@ -65,5 +82,5 @@
     private GeneticAlgorithm CreateGaTspSample() {
       GeneticAlgorithm ga = new GeneticAlgorithm();
-      #region problem configuration
+      #region Problem Configuration
       TravelingSalesmanProblem tspProblem = new TravelingSalesmanProblem();
       tspProblem.ImportFromTSPLIB("ch130.tsp", "ch130.opt.tour", 6110);
@@ -74,5 +91,5 @@
       tspProblem.Description = "130 city problem (Churritz)";
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       ga.Name = "Genetic Algorithm - TSP";
       ga.Description = "A genetic algorithm which solves the \"ch130\" traveling salesman problem (imported from TSPLIB)";
@@ -90,5 +107,4 @@
       return ga;
     }
-
     #endregion
     #region VRP
@@ -112,5 +128,5 @@
     private GeneticAlgorithm CreateGaVrpSample() {
       GeneticAlgorithm ga = new GeneticAlgorithm();
-      #region problem configuration
+      #region Problem Configuration
       VehicleRoutingProblem vrpProblem = new VehicleRoutingProblem();
 
@@ -130,5 +146,5 @@
       vrpProblem.Vehicles.Value = 25;
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       ga.Name = "Genetic Algorithm - VRP";
       ga.Description = "A genetic algorithm which solves the \"C101\" vehicle routing problem (imported from Solomon)";
@@ -161,8 +177,6 @@
       return ga;
     }
-
     #endregion
     #region ArtificialAnt
-
     [TestMethod]
     public void CreateGpArtificialAntSampleTest() {
@@ -191,5 +205,5 @@
     public GeneticAlgorithm CreateGpArtificialAntSample() {
       GeneticAlgorithm ga = new GeneticAlgorithm();
-      #region problem configuration
+      #region Problem Configuration
       ArtificialAntProblem antProblem = new ArtificialAntProblem();
       antProblem.BestKnownQuality.Value = 89;
@@ -200,5 +214,5 @@
       antProblem.MaxTimeSteps.Value = 600;
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       ga.Name = "Genetic Programming - Artificial Ant";
       ga.Description = "A standard genetic programming algorithm to solve the artificial ant problem (Santa-Fe trail)";
@@ -222,7 +236,6 @@
       return ga;
     }
-
-    #endregion
-    #region symbolic regression
+    #endregion
+    #region Symbolic Regression
     [TestMethod]
     public void CreateGpSymbolicRegressionSampleTest() {
@@ -250,5 +263,5 @@
     private GeneticAlgorithm CreateGpSymbolicRegressionSample() {
       GeneticAlgorithm ga = new GeneticAlgorithm();
-      #region problem configuration
+      #region Problem Configuration
       SymbolicRegressionSingleObjectiveProblem symbRegProblem = new SymbolicRegressionSingleObjectiveProblem();
       symbRegProblem.Name = "Tower Symbolic Regression Problem";
@@ -323,5 +336,5 @@
       symbRegProblem.EvaluatorParameter.Value = new SymbolicRegressionSingleObjectivePearsonRSquaredEvaluator();
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       ga.Problem = symbRegProblem;
       ga.Name = "Genetic Programming - Symbolic Regression";
@@ -345,6 +358,5 @@
     }
     #endregion
-    #region symbolic classification
-
+    #region Symbolic Classification
     [TestMethod]
     public void CreateGpSymbolicClassificationSampleTest() {
@@ -373,5 +385,5 @@
     private GeneticAlgorithm CreateGpSymbolicClassificationSample() {
       GeneticAlgorithm ga = new GeneticAlgorithm();
-      #region problem configuration
+      #region Problem Configuration
       SymbolicClassificationSingleObjectiveProblem symbClassProblem = new SymbolicClassificationSingleObjectiveProblem();
       symbClassProblem.Name = "Mammography Classification Problem";
@@ -439,5 +451,5 @@
       symbClassProblem.EvaluatorParameter.Value = new SymbolicClassificationSingleObjectiveMeanSquaredErrorEvaluator();
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       ga.Problem = symbClassProblem;
       ga.Name = "Genetic Programming - Symbolic Classification";
@@ -485,5 +497,5 @@
     private EvolutionStrategy CreateEsGriewankSample() {
       EvolutionStrategy es = new EvolutionStrategy();
-      #region problem configuration
+      #region Problem Configuration
       SingleObjectiveTestFunctionProblem problem = new SingleObjectiveTestFunctionProblem();
 
@@ -498,5 +510,5 @@
       problem.Description = "Test function with real valued inputs and a single objective.";
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       es.Name = "Evolution Strategy - Griewank";
       es.Description = "An evolution strategy which solves the 10-dimensional Griewank test function";
@@ -516,5 +528,4 @@
       return es;
     }
-
     #endregion
     #endregion
@@ -540,5 +551,5 @@
     private IslandGeneticAlgorithm CreateIslandGaTspSample() {
       IslandGeneticAlgorithm ga = new IslandGeneticAlgorithm();
-      #region problem configuration
+      #region Problem Configuration
       TravelingSalesmanProblem tspProblem = new TravelingSalesmanProblem();
       tspProblem.ImportFromTSPLIB("ch130.tsp", "ch130.opt.tour", 6110);
@@ -549,5 +560,5 @@
       tspProblem.Description = "130 city problem (Churritz)";
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       ga.Name = "Island Genetic Algorithm - TSP";
       ga.Description = "An island genetic algorithm which solves the \"ch130\" traveling salesman problem (imported from TSPLIB)";
@@ -566,5 +577,4 @@
       return ga;
     }
-
     #endregion
     #endregion
@@ -590,5 +600,5 @@
     private LocalSearch CreateLocalSearchKnapsackSample() {
       LocalSearch ls = new LocalSearch();
-      #region problem configuration
+      #region Problem Configuration
       KnapsackProblem problem = new KnapsackProblem();
       problem.BestKnownQuality = new DoubleValue(362);
@@ -607,5 +617,5 @@
       problem.Description = "Represents a Knapsack problem.";
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       ls.Name = "Local Search - Knapsack";
       ls.Description = "A local search algorithm that solves a randomly generated Knapsack problem";
@@ -624,10 +634,8 @@
       ls.Seed.Value = 0;
       ls.SetSeedRandomly.Value = true;
-
       #endregion
       ls.Engine = new ParallelEngine();
       return ls;
     }
-
     #endregion
     #endregion
@@ -659,5 +667,5 @@
     private ParticleSwarmOptimization CreatePsoSchwefelSample() {
       ParticleSwarmOptimization pso = new ParticleSwarmOptimization();
-      #region problem configuration
+      #region Problem Configuration
       var problem = new SingleObjectiveTestFunctionProblem();
       problem.BestKnownQuality.Value = 0.0;
@@ -669,5 +677,5 @@
       problem.SolutionCreator = new UniformRandomRealVectorCreator();
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       pso.Name = "Particle Swarm Optimization - Schwefel";
       pso.Description = "A particle swarm optimization algorithm which solves the 2-dimensional Schwefel test function (based on the description in Pedersen, M.E.H. (2010). PhD thesis. University of Southampton)";
@@ -705,5 +713,4 @@
       pso.Seed.Value = 0;
       pso.SetSeedRandomly.Value = true;
-
       #endregion
       pso.Engine = new ParallelEngine();
@@ -730,5 +737,5 @@
     private SimulatedAnnealing CreateSimulatedAnnealingRastriginSample() {
       SimulatedAnnealing sa = new SimulatedAnnealing();
-      #region problem configuration
+      #region Problem Configuration
       var problem = new SingleObjectiveTestFunctionProblem();
       problem.BestKnownQuality.Value = 0.0;
@@ -740,5 +747,5 @@
       problem.SolutionCreator = new UniformRandomRealVectorCreator();
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       sa.Name = "Simulated Annealing - Rastrigin";
       sa.Description = "A simulated annealing algorithm that solves the 2-dimensional Rastrigin test function";
@@ -799,5 +806,5 @@
     private TabuSearch CreateTabuSearchTspSample() {
       TabuSearch ts = new TabuSearch();
-      #region problem configuration
+      #region Problem Configuration
       var tspProblem = new TravelingSalesmanProblem();
       tspProblem.ImportFromTSPLIB("ch130.tsp", "ch130.opt.tour", 6110);
@@ -808,5 +815,5 @@
       tspProblem.Description = "130 city problem (Churritz)";
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       ts.Name = "Tabu Search - TSP";
       ts.Description = "A tabu search algorithm that solves the \"ch130\" TSP (imported from TSPLIB)";
@@ -853,5 +860,4 @@
       return ts;
     }
-
     #endregion
     #endregion
@@ -877,5 +883,5 @@
     private VariableNeighborhoodSearch CreateVnsTspSample() {
       VariableNeighborhoodSearch vns = new VariableNeighborhoodSearch();
-      #region problem configuration
+      #region Problem Configuration
       TravelingSalesmanProblem tspProblem = new TravelingSalesmanProblem();
       tspProblem.BestKnownSolution = new Permutation(PermutationTypes.Absolute, new int[] {
@@ -893,5 +899,5 @@
       tspProblem.Description = "Represents a symmetric Traveling Salesman Problem.";
       #endregion
-      #region algorithm configuration
+      #region Algorithm Configuration
       vns.Name = "Variable Neighborhood Search - TSP";
       vns.Description = "A variable neighborhood search algorithm which solves a funny TSP instance";
@@ -938,8 +944,8 @@
       return vns;
     }
-
-    #endregion
-    #endregion
-    #region helper
+    #endregion
+    #endregion
+
+    #region Helpers
     private void ConfigureEvolutionStrategyParameters<R, M, SC, SR, SM>(EvolutionStrategy es, int popSize, int children, int parentsPerChild, int maxGens, bool plusSelection)
       where R : ICrossover