Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Core.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Core.cs	(revision 6521)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Core.cs	(revision 6546)
@@ -25,4 +25,5 @@
 using System.Threading;
 using System.Threading.Tasks;
+using HeuristicLab.Clients.Hive.SlaveCore.Properties;
 using HeuristicLab.Clients.Hive.SlaveCore.ServiceContracts;
 using HeuristicLab.Common;
@@ -53,5 +54,5 @@
 
     public Core() {
-      var log = new ThreadSafeLog(new Log());
+      var log = new ThreadSafeLog(new Log(Settings.Default.MaxLogCount));
       this.pluginManager = new PluginManager(WcfService.Instance, log);
       this.jobManager = new JobManager(pluginManager, log);
@@ -408,5 +409,4 @@
     private void log_MessageAdded(object sender, EventArgs<string> e) {
       clientCom.LogMessage(e.Value.Split('\t')[1]);
-      ((ILog)sender).Clear(); // don't let the log take up memory
     }
     #endregion
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Properties/Settings.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Properties/Settings.Designer.cs	(revision 6521)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Properties/Settings.Designer.cs	(revision 6546)
@@ -2,5 +2,5 @@
 // <auto-generated>
 //     This code was generated by a tool.
-//     Runtime Version:4.0.30319.225
+//     Runtime Version:4.0.30319.235
 //
 //     Changes to this file may cause incorrect behavior and will be lost if
@@ -275,4 +275,16 @@
             }
         }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("1")]
+        public int MaxLogCount {
+            get {
+                return ((int)(this["MaxLogCount"]));
+            }
+            set {
+                this["MaxLogCount"] = value;
+            }
+        }
     }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Properties/Settings.settings
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Properties/Settings.settings	(revision 6521)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Properties/Settings.settings	(revision 6546)
@@ -66,4 +66,7 @@
       <Value Profile="(Default)">hiveslave</Value>
     </Setting>
+    <Setting Name="MaxLogCount" Type="System.Int32" Scope="User">
+      <Value Profile="(Default)">1</Value>
+    </Setting>
   </Settings>
 </SettingsFile>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app_ascheibe.config
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app_ascheibe.config	(revision 6521)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app_ascheibe.config	(revision 6546)
@@ -75,4 +75,7 @@
         <value>hiveslave</value>
       </setting>
+      <setting name="MaxLogCount" serializeAs="String">
+        <value>1</value>
+      </setting>
     </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
   </userSettings>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app_f005pc.config
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app_f005pc.config	(revision 6521)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app_f005pc.config	(revision 6546)
@@ -75,4 +75,7 @@
         <value>hiveslave</value>
       </setting>
+      <setting name="MaxLogCount" serializeAs="String">
+        <value>1</value>
+      </setting>
     </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
   </userSettings>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app_services.config
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app_services.config	(revision 6521)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/app_services.config	(revision 6546)
@@ -75,4 +75,7 @@
         <value>hiveslave</value>
       </setting>
+      <setting name="MaxLogCount" serializeAs="String">
+        <value>1</value>
+      </setting>
     </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
   </userSettings>